#include <kpanel.h>
#include <kpanel.moc>

#include <kconfig.h>
#include <kdevice.h>

#include <qfiledialog.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qpoint.h>
#include <qstring.h>

#include <xpm/dir.xpm>
#include <xpm/wave.xpm>
#include <xpm/floppy.xpm>
#include <xpm/dspapp.xpm>

/* constants */
const char* chRecordfile = "Recordfile";
const char* chPlayfile = "Playfile";
const char* chDSPfile = "DSP Filepath";
const QRect rRecordfile(60, 18, 90, 20);
const QRect rPlayfile(60, 45, 90, 20);
const QRect rDSPfile(60, 72, 90, 20);
const QRect rRecordfilel(150, 18, 250, 20);
const QRect rPlayfilel(150,45, 250, 20);
const QRect rDSPfilel(150,72, 250, 20);
const QRect rRecordfilebtn(410, 15, 26, 26);
const QRect rPlayfilebtn(410, 42, 26, 26);
const QRect rDSPfilebtn(410, 69, 26, 26);
const char* chDir = "Files";
const QPoint ptDir(30,20);
const QPoint ptDirPixmap(8,8);
const char* chOffline = "Offline";
const char* chSoundblaster = "Soundblaster";
const char* chDSP56 = "DSP56-3";
const char* chSine = "Sine generator";

extern KConfig* config;
extern WaveInfoStruct WaveInfo;

KPanel::KPanel(QWidget *parent, const char *name)
	: QFrame(parent, name)
{
/*	recordfile = new QLineEdit(this);
	playfile = new QLineEdit(this);
	dspfilepath = new QLineEdit(this);
	recordfilebtn = new QPushButton(this);
	playfilebtn = new QPushButton(this);
	dspfilepathbtn = new QPushButton(this);

	recordfile->setGeometry(rRecordfilel);
	playfile->setGeometry(rPlayfilel);
	dspfile->setGeometry(rDSPfilel);
	recordfilebtn->setGeometry(rRecordfilebtn);
	recordfilebtn->setPixmap(QPixmap((const char **)floppy_xpm));
	playfilebtn->setGeometry(rPlayfilebtn);
	playfilebtn->setPixmap(QPixmap((const char **)wave_xpm));
	dspfilepathbtn->setGeometry(rDSPfilebtn);
	dspfilepathbtn->setPixmap(QPixmap((const char **)dspapp_xpm));

	connect(recordfilebtn, SIGNAL(clicked()), this, SLOT(record()));
	connect(playfilebtn, SIGNAL(clicked()), this, SLOT(play()));
	connect(dspfilebtn, SIGNAL(clicked()), this, SLOT(dsp()));

	recordfile->setText(config->readEntry(chRecordfile, ""));
	playfile->setText(config->readEntry(chPlayfile, ""));
	dspfile->setText(config->readEntry(chDSPfile, ""));*/

	f = QFont("Times", 24);//, QFont::Bold);
	setFont(f);
}

KPanel::~KPanel()
{
}

void KPanel::paintEvent(QPaintEvent* ev)
{
	QFrame::paintEvent(ev);
	
	QPainter paint(this);

	if(WaveInfo.iDevice == 0)
		paint.drawText(50,50,chOffline);
	else if(WaveInfo.iDevice == WAVEIN)
		paint.drawText(50,50,chSoundblaster);
	else if(WaveInfo.iDevice == DSP56)
		paint.drawText(50,50,chDSP56);
	else if(WaveInfo.iDevice == SINEGENERATOR)
		paint.drawText(50,50,chSine);
/*	paint.drawPixmap(ptDirPixmap,QPixmap((const char **)directory_xpm));
	paint.drawText(ptDir,chDir);
	paint.drawText(rRecordfile, AlignCenter, chRecordfile);
	paint.drawText(rPlayfile, AlignCenter, chPlayfile);
	paint.drawText(rDSPfile, AlignCenter, chDSPfile);*/
}
/*
void KPanel::record()
{
	QString filename = QFileDialog::getOpenFileName(0, "*.wav");
	if(filename.isNull()) return;
	recordfile->setText(filename);
	config->writeEntry(chRecordfile, filename);
	config->sync();
}

void KPanel::play()
{
	QString filename = QFileDialog::getOpenFileName(0, "*.wav");
	if(filename.isNull()) return;
	playfile->setText(filename);
	config->writeEntry(chPlayfile, filename);
	config->sync();
}

void KPanel::dsp()
{
	QString filename = QFileDialog::getOpenFileName(0, "*.lod");
	if(filename.isNull()) return;
	dspfile->setText(filename);
	config->writeEntry(chDSPfile, filename);
	config->sync();
}
*/
